Ghost listener
==============

Introduction
------------

The ghost listener is the listener for each ghost device running continuously.

It can perform various operations:

- Deploy service on the device
- Broadcast informations on the status of all connected sensors/actuators
- Set known devices state
- Scan for devices

API communication
-----------------

The communications are always HTTP, with a basic auth process.

For authenticated service, **401 UNAUTHORIZED** is sent if authentication failed.

|Service         |Authenticated?|Entry point       |Method|Success code|Failure code|
|----------------|--------------|------------------|------|------------|------------|
|Get all standard informations|NO|`/ghost/info`|`GET`|200 OK|||
|Get token|NO|`/ghost/token`|`GET`|200 OK|401 UNAUTHORIZED|
|Get the ghost device current status|YES|`/ghost/status`|`GET`|200 OK||
|Launch a scan for devices|YES|`/ghost/devices`|`POST`|202 ACCEPTED|208 ALREADY REPORTED|
|Get scanner state|YES|`/ghost/devices`|`TRACE`|200 OK||
|Stop a currently running scan|YES|`/ghost/devices`|`DELETE`|202 ACCEPTED|428 PRECONDITION REQUIRED|
|Get the state of a device|YES|`/ghost/devices/DEVICE_ID/state`|`GET`|200 OK|400 BAD REQUEST|
|Set the state of a device|YES|`/ghost/devices/DEVICE_ID/state`|`PUT`|200 OK|400 BAD REQUEST|

**Useful commands**

- To monitor current known devices, run (locally with default configuration)

  ```sh
  watch -tn 0,1 curl -sS test:test@127.0.0.1:16560/ghost/devices
  ```
  
- To monitor current scanner state, run (locally with default configuration)

  ```sh
  watch -tn 0,1 curl -sS test:test@127.0.0.1:16560/ghost/devices -X TRACE
  ```

Configuration file
------------------

**Default configuration file:**

```
# Generated by Ghost version 1.0-V-2018-02-28T08:26:08
# Please always use spaces, never tabulate...

[Device]
deviceName: ToBeSet

[Authentication]
username: test
password: test
isAuthenticationManagerDataPersistent: true

[Network]
# Listen on one specified ip, or on all interface with *
listenOnIP: *
listenOnPort: 16560

[Scanner]
# The interfaces devices won't be looking for on (comma separated)
scannerInterfaceFilter: lo, docker0
scannerThreadCount: 50
scannerConnectionTimeout: 500
scannerRequestTimeout: 2000
# The address to scan in addition to found interface address (comma separated, X.X.X.X/CIDR)
scannerUserAddress: 192.168.1.0/24
scannerTypeFilter:
scannerUUIDFilter:  
```

**Informations:**

Please notice that when running the program for the first time, the ghost client configuration
file will be automatically created. The configuration filename is GhostClient.conf, and must be
put the same folder then the one executing the NGhostClient program.

**Properties details:**

|Property|Description|Type|Default value|Other value examples|
|--------|-----------|----|-------------|--------------------|
|`deviceName`|The name associated with the device|String|`ToBeSet`||
|`username`|The username to give during HTTP authentication process|String|`test`||
|`password`|The password to give during HTTP authentication process|String|`test`||
|`isAuthenticationManagerDataPersistent`|Does client save recovered authentication data|Boolean|`true`||
|`listenOnIp`|The IP the device should be listen on (or * for listening on all interfaces)|String|`*`|X.X.X.X or *|
|`listenOnPort`|The port the device should be listen on|Integer|`16560`||
|`scannerInterfaceFilter`|The interface which won't be scanned|String list (comma separated)|`lo`|lo, docker0|
|`scannerThreadCount`|The threads count which will be running for one scan|Integer|`50`||
|`scannerConnectionTimeout`|The connection timeout for scanner (ms)|Integer|`500`||
|`scannerRequestTimeout`|The request timeout for scanner (ms)|Integer|`1000`||
|`scannerUserAddress`|The additionnal ip range to scan with a X.X.X.X/CIDR shape, comma separated|String||192.168.0.0/24, 10.0.0.0/24|
|`scannerUUIDFilter`|The UUID which should be ignored during the scan (AAAA:BBBB:CCCC:DDDD model)|String list, comma separated||0C02-000F-0001-FEDC, ABCD-1234-ABCD-4567|
|`scannerTypeFilter`|The device type which should be ignored during the scan|String list||HUE for philips hue devices, GHOST for ghost devices|

Please notice that when changing your *listenOnPort* option, other scanners won't be able to find your
device if their listening port is not the same then the one set by default (16560)

Scenario example
----------------

When starting the ghost client, you'll first have to run a scan on configured network or known
interfaces for ghost client to start dialoging with it.

```bash
curl test:test@127.0.0.1:16560/ghost/devices -X POST
```

Once scan is done, you can access device by index or by UUID.

```bash
curl test:test@127.0.0.1:16560/ghost/devices/0
```

If you don't wish to use the username/password combination, you can get a token by input:

Ghost client side:

```
AllowToken
```

Token request side:
```bash
curl 127.0.0.1:16560/ghost/token
```

If you do it right, you'll get a token with this template

`CNST-RANDRANDRANDRAND-RAND`

Where CNST is a part associated with ghost device type, and RAND are randomly generated
character/number set.

If you do not type `AllowToken` in client you will face an Unauthorized 401.

**When discovering a ghost device**, the ghost client will make repeated attempts to get
a token from this ghost device. You'll have to allow token obtention by typing `AllowToken`
or by any developped method to authorize it.

Once synchronized with a ghost device, the ghost client will transmit to it its known
authentication details, for the ghost device to be able to communicate with every other devices.

When an authentication detail is added to the ghost client, it will be automatically broadcast to all
synchronized devices.

[Token attack methods]

- Send multiple tokens requests at the same time a legit client is doing
request could cause token to be given to unauthorized user.
- When scanning, a non-ghost software could pretent to be one, and then
synchronized with ghost client. Once synchronized, he gets all the authentication
details on the network.

HUE Device
----------

When hue device is detected, the authentication manager will try at regular interval (2 seconds)
to get an access token, if you never access it before. You'll have to push the HUE hub button to
get a token.

The token will then be manager by NDeviceHUE instance, and be saved into `HUE/HUE_DEVICE_ID` file,
and will be loaded when device is discovered again.

> What hue request looks like?

If you have a HUE device detected as 0th device, you execute

```bash
curl test:test@127.0.0.1:16560/ghost/devices/0/state
```

And you'll get this answer

```json
{
    "authentication": {
        "isAuthenticated": true,
        "apiKey": "BsjBzdygFKz4VbFVzDElfqEwIoN8WqF4H39pjPQk"
    },
    "lights": {
        "count": 2,
        "lastUpdate": 1526545698,
        "0": {
            "name": "Hue go 1",
            "type": "Globe",
            "id": 4,
            "state": {
                "isOn": false,
                "isReachable": false,
                "color": {
                    "brightness": 164,
                    "saturation": 210,
                    "hue": 17596,
                    "xy": [
                        0.3413,
                        0.5426
                    ],
                    "temperature": 187,
                    "mode": "hs"
                },
                "misc": {
                    "effect": "none",
                    "alert": "none"
                }
            }
        },
        "1": {
            "name": "MDR",
            "type": "Strip",
            "id": 5,
            "state": {
                "isOn": false,
                "isReachable": true,
                "color": {
                    "brightness": 197,
                    "saturation": 140,
                    "hue": 8418,
                    "xy": [
                        0.4573,
                        0.41
                    ],
                    "temperature": 366,
                    "mode": "ct"
                },
                "misc": {
                    "effect": "none",
                    "alert": "none"
                }
            }
        }
    }
}
```

> How to edit light properties?
 
```bash
curl test:test@127.0.0.1:16560/ghost/devices/HUE_DEVICE_INDEX/state/lights -X PUT --data-binary "@/PATH/TO/FILE.json"
```

With this file

```json
{
	"0":
	{
		"name": "Light 0!"
	},
	"1":
	{
		"state":
		{
			"isOn": true,
			"color":
			{
				"hue": 5000,
				"brightness": 255
			}
		}
	}
}
```

To set the light 0 name to "Light 0!", and the current hue of light 1 to 5000/brightness to 255.

*Please be aware of name changes: You can't edit name + state of one light at the same time.*

You can edit lights properties with a PUT method through many ways:

- All lights at one time with /ghost/devices/DEVICE_ID/state/lights

  For example:

  - For a configuration of multiple lights at the same time:

    ```bash
    curl test:test@127.0.0.1:16560/ghost/devices/0/state/lights -X PUT -d "{ \"0\": { \"state\": { \"isOn\": true, \"color\": { \"brightness\": 50 } } }, \"1\": { \"name\": \"LampeSalon\" }"
    ```

    == The light with 0 index will be on with a brightness of 50, and the light with index 1 will changed name to "LampeSalon"

  - For a configuration of all lights at the same time:

    ```bash
    curl test:test@127.0.0.1:16560/ghost/devices/0/state/lights -X PUT -d "{ \"state\": { \"isOn\": true, \"color\": { \"brightness\": 150, \"hue\": 17000 } } }"
    ```

    == All the lights will be on with a brightness of 150, and a hue of 17000

- One light at a time with /ghost/devices/DEVICE_ID/state/lights/LIGHT_NAME/ or /ghost/devices/DEVICE_ID/state/lights/LIGHT_INDEX/

  For example:

    ```bash
    curl test:test@127.0.0.1:16560/ghost/devices/0/state/lights/0 -X PUT -d "{ \"state\": { \"isOn\": true, \"color\": { \"saturation\": 50 } } }"
    ```

  == This will light up the light index 0, and set saturation to 50
 
- One specific light property with /ghost/devices/DEVICE_ID/state/lights/LIGHT_NAME_OR_INDEX/property

  For example:

  - Change brightness:

    ```bash
    curl test:test@127.0.0.1:16560/ghost/devices/0/state/lights/LampeSalon/state/color/brightness -X PUT -d "{ \"brightness\": 255 }"
    ```

    == This will change brightness of light named "LampeSalon" to 255

  - Change name:

    ```bash
    curl test:test@127.0.0.1:16560/ghost/devices/0/state/lights/LampeSalon/name -X PUT -d "{ \"name\": \"LampeChambre\" }"
    ```

    == This will change name of light named "LampeSalon" to "LampeChambre"
    
  - Change color to blue, maximum saturation, maximum brightness, disable color loop and blink all lights
  
  ```bash
  curl test:test@127.0.0.1:16560/ghost/devices/2/state/lights/ -X PUT -d "{ \"state\": { \"color\": { \"hue\": 45000, \"saturation\": 255, \"brightness\": 255 }, \"misc\": { \"alert\": \"select\", \"effect\": \"none\" } } }"
  ```

**Complete editables properties list for each light:**

|Key|Type|Description|
|---|----|-----------|
|name|String|The name to assign to device|
|state.isOn|Boolean|Is the device light up?|
|state.color.brightness|Integer|The light brightness (0-255)|
|state.color.saturation|Integer|HUE/Saturation component (0-255)|
|state.color.hue|Integer|HUE/Saturation component (0-65535)|
|state.color.xy|Double array|xy component|
|state.color.temperature|Integer|Color temperature component|
|misc.effect|String|Can be "colorloop" or "none"|
|misc.alert|String|Can be "select", "lselect", or "none"|

Audio devices
-------------

The ghost audio devices can be controled with ghost client with:

> Start a sound synchronized with 2 devices

POST /ghost/devices/X/state/audio/start

{
	"track":
	{
		"name": "AAA",
		"hostname": "XX",
		"port": YY,
		"path": "/ZZ/ZZ/ZZ"
	},
	"synch":
	[
		"11",
		"22"
	],
	"isLoop": false,
	"volume": 50,
}

Please note the track hostname/port/path refers to remote sftp or http server,
and authentication has to be known to access it. (*Cf. Authentication manager*)

Door opener device
------------------

When a door opener device is detected you can:

> Open the door:

```curl
curl test:test@127.0.0.1:16560/ghost/devices/2/state/open -X POST
```

Action and event pile
---------------------

Via the /ghost/action/ URI, you can view all the available actions on found devices (after scan).

You can execute the action via POST /ghost/action/ACTION_HASH, potentially with parameters expressed as:

```json
{
	"parameter": [ 1, 2, 3 ]
}
```

for example.

Once scan is finished, if ghost watcher are found and associated with device, you'll be able to execute the
same request then before but with PUT method, and the event will be pushed to the watcher event pile.

Dependencies
------------

- NLib
- NHTTP
- NGhostCommon
- NParser
- NJson
- NDeviceCommon
- NDeviceHUE
- NDeviceScanner

Author
------

SOARES Lucas <lucas.soares.npro@gmail.com>

https://gitlab.com/MasterProject_M1/NDevice/NDeviceGhost/NGhostClient.git
